//em.js - EuroMillions data type

class EuroMillions{
    constructor(
        p_numbers,
        p_stars
    ){
        p_numbers =
            p_numbers===undefined ?
                col_aleatoria(1, 50, 5, false)
            :
            p_numbers

        if(p_stars===undefined)
            p_stars = col_aleatoria(1, 12, 2, false)

        this.mNumbers = p_numbers
        this.mStars = p_stars
    }//constructor

    toString(
        p_list_type="ul"
    ){
        var html="<ul>"

        // lista para representar os números
        var lnums=`<${p_list_type}>`
        for(var num of this.mNumbers)
            lnums+=`<li>${num}</li>`
        lnums+=`</${p_list_type}>`

        // lista para representar as estrelas
        var lstars=`<${p_list_type}>`
        for(var star of this.mStars)
            lstars+=`<li>&star;${star}&star;</li>`
        lstars+=`</${p_list_type}>`

        // juntá-las
        html+=`<li>${lnums}</li>`
        html+=`<li>${lstars}</li>`

        html+="</ul>"
        return html
    }//toString

    static how_to_sort_numbers_asc(n1,n2){
        n1=Number(n1); n2=Number(n2)
        if(n1>n2) return 1
        if(n1<n2) return -1
        return 0
    }//how_to_sort_numbers_asc

    sort_bet(
        p_asc=true
    ){
        // mostra uma var q corresponde a um método estático
        var how_to_asc =
            EuroMillions.how_to_sort_numbers_asc

        // uma var que é uma função anónima
        var contrary = function(n1, n2){
            return -1 *
            EuroMillions.how_to_sort_numbers_asc(n1,n2)
        }

        // uma condicional que tira partido dos identificadores acima
        if(p_asc){
            this.mNumbers.sort(how_to_asc)
            this.mStars.sort(how_to_asc)
        }
        else{ // se a ordenação pedida é descendente
            this.mNumbers.sort(contrary)
            this.mStars.sort(contrary)
        }
    }//sort_bet

    randomize(){
        this.mNumbers = col_aleatoria(1,50,5,false)
        this.mStars = col_aleatoria(1,12,2,false)
    }//randomize

    accounting_relative_to(
        p_the_1st_prize_bet
    ){
        var how_many_numbers_right=0,
            how_many_stars_right=0
        for(var prized_number of p_the_1st_prize_bet.mNumbers){
            var how_many_times_it_exists_in_this_bet =
                procurar_na_col(
                    this.mNumbers,
                    prized_number
                ).length
            how_many_numbers_right+=
                how_many_times_it_exists_in_this_bet
        }//contabilidade dos números

        for(var prized_star of p_the_1st_prize_bet.mStars){
            var how_many_times_it_exists_in_this_bet =
                procurar_na_col(
                    this.mStars,
                    prized_star
                ).length
            how_many_stars_right+=
                how_many_times_it_exists_in_this_bet
        }//contabilidade das estrelas

        var dictionary_of_two_values =
        {
            "nums_right":how_many_numbers_right,
            "stars_right":how_many_stars_right
        }

        return dictionary_of_two_values
    }//accounting_relative_to
}//class EuroMillions